Index: src/unittests/BoxUnittest.hpp
===================================================================
--- src/unittests/BoxUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/BoxUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,56 @@
+/*
+ * BoxUnittest.hpp
+ *
+ *  Created on: Jul 30, 2010
+ *      Author: crueger
+ */
+
+#ifndef BOXUNITTEST_HPP_
+#define BOXUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Matrix;
+class Box;
+
+class BoxUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( BoxUnittest );
+  CPPUNIT_TEST ( setBoxTest );
+  CPPUNIT_TEST ( translateInOutTest );
+  CPPUNIT_TEST ( isInsideTest );
+  CPPUNIT_TEST ( WrapExplodeTest );
+  CPPUNIT_TEST ( BoundaryBounceTest );
+  CPPUNIT_TEST ( BoundaryIgnoreTest );
+  CPPUNIT_TEST ( BoundaryMixedTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void setBoxTest();
+  void translateInOutTest();
+  void isInsideTest();
+  void WrapExplodeTest();
+  void BoundaryBounceTest();
+  void BoundaryIgnoreTest();
+  void BoundaryMixedTest();
+
+  Matrix *unit;
+  Matrix *zero;
+  Matrix *invertible;
+  Matrix *uninvertible;
+
+  Box *unitBox;
+  Box *stretchedBox1;
+  Box *stretchedBox2;
+  Box *stretchedBox3;
+  Box *stretchedBox4;
+  Box *tiltedBox1;
+  Box *tiltedBox2;
+  Box *tiltedBox3;
+  Box *tiltedBox4;
+};
+
+#endif /* BOXUNITTEST_HPP_ */
Index: src/unittests/CacheableTest.cpp
===================================================================
--- src/unittests/CacheableTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/CacheableTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "CacheableTest.hpp"
Index: src/unittests/CountBondsUnitTest.cpp
===================================================================
--- src/unittests/CountBondsUnitTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/CountBondsUnitTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,8 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -54,16 +58,16 @@
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(-0.2418, 0.9350, 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(-0.2418, 0.9350, 0. ));
   TestMolecule1->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0.9658, 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0.9658, 0., 0. ));
   TestMolecule1->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = oxygen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(oxygen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule1->AddAtom(Walker);
 
@@ -72,16 +76,16 @@
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(-0.2418, 0.9350, 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(-0.2418, 0.9350, 0. ));
   TestMolecule2->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = hydrogen;
-  *Walker->node = Vector(0.9658, 0., 0. );
+  Walker->setType(hydrogen);
+  Walker->setPosition(Vector(0.9658, 0., 0. ));
   TestMolecule2->AddAtom(Walker);
   Walker = World::getInstance().createAtom();
   CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-  Walker->type = oxygen;
-  *Walker->node = Vector(0., 0., 0. );
+  Walker->setType(oxygen);
+  Walker->setPosition(Vector(0., 0., 0. ));
   TestMolecule2->AddAtom(Walker);
 
Index: src/unittests/DummyUI.hpp
===================================================================
--- src/unittests/DummyUI.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/DummyUI.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,60 @@
+/*
+ * DummyUI.h
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: crueger
+ */
+
+#ifndef DUMMYUI_H_
+#define DUMMYUI_H_
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+class DummyDialog : public Dialog
+{
+public:
+  DummyDialog(){}
+  virtual ~DummyDialog(){}
+
+  virtual void queryEmpty(const char *, std::string = ""){}
+  virtual void queryBoolean(const char *, std::string = ""){}
+  virtual void queryInt(const char *, std::string = ""){}
+  virtual void queryInts(const char *, std::string = ""){}
+  virtual void queryString(const char*, std::string = ""){}
+  virtual void queryStrings(const char*, std::string = ""){}
+  virtual void queryDouble(const char*, std::string = ""){}
+  virtual void queryDoubles(const char*, std::string = ""){}
+  virtual void queryAtom(const char*,std::string = ""){}
+  virtual void queryAtoms(const char*,std::string = ""){}
+  virtual void queryMolecule(const char*,std::string = ""){}
+  virtual void queryMolecules(const char*,std::string = ""){}
+  virtual void queryVector(const char*,bool, std::string = ""){}
+  virtual void queryVectors(const char*,bool, std::string = ""){}
+  virtual void queryBox(const char*, std::string = ""){}
+  virtual void queryElement(const char*, std::string = ""){}
+  virtual void queryElements(const char*, std::string = ""){}
+};
+
+class DummyUIFactory : public UIFactory
+{
+public:
+  virtual ~DummyUIFactory(){}
+
+  virtual Dialog* makeDialog(){return new DummyDialog;}
+  virtual MainWindow* makeMainWindow(){return 0;}
+
+  struct description : public UIFactory::factoryDescription {
+    description():
+        UIFactory::factoryDescription("Dummy")
+    {}
+    virtual ~description(){}
+
+    virtual UIFactory* makeFactory(){return new DummyUIFactory;};
+  };
+
+protected:
+  DummyUIFactory(){}
+};
+
+#endif /* DUMMYUI_H_ */
Index: src/unittests/FormulaUnittest.cpp
===================================================================
--- src/unittests/FormulaUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/FormulaUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,263 @@
+/*
+ * FormulaUnittest.cpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "FormulaUnittest.hpp"
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <iostream>
+
+#include "Formula.hpp"
+#include "World.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+using namespace std;
+
+CPPUNIT_TEST_SUITE_REGISTRATION( FormulaUnittest );
+
+void FormulaUnittest::setUp(){}
+void FormulaUnittest::tearDown(){
+  World::purgeInstance();
+}
+
+void FormulaUnittest::baseTest(){
+  Formula formula;
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)0);
+  CPPUNIT_ASSERT(formula.begin()==formula.end());
+
+  // test some one letter element names
+  formula += "H";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)1);
+  CPPUNIT_ASSERT(formula.begin()!=formula.end());
+  formula += "H";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)2);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)1);
+  CPPUNIT_ASSERT(formula.begin()!=formula.end());
+  formula += "O";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)2);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)2);
+  CPPUNIT_ASSERT(formula.begin()!=formula.end());
+
+  // test copy constructor
+  Formula formula2=formula;
+  CPPUNIT_ASSERT_EQUAL(formula2["H"],(unsigned int)2);
+  CPPUNIT_ASSERT_EQUAL(formula2["O"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula2["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula2.getElementCount(),(unsigned int)2);
+  CPPUNIT_ASSERT(formula2.begin()!=formula2.end());
+
+  // test Assignment operator
+  formula2=Formula();
+  CPPUNIT_ASSERT_EQUAL(formula2["H"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula2["O"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula2["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula2.getElementCount(),(unsigned int)0);
+  CPPUNIT_ASSERT(formula2.begin()==formula2.end());
+
+  // test comparison
+  CPPUNIT_ASSERT(formula!=formula2);
+  Formula formula3;
+  formula3 += "H";
+  formula3 += "H";
+  formula3 += "O";
+  CPPUNIT_ASSERT(formula==formula3);
+
+  // inequality
+  formula3 += "O";
+  CPPUNIT_ASSERT(formula!=formula3);
+
+  // after removing it should be fine again
+  formula3 -= "O";
+  CPPUNIT_ASSERT(formula==formula3);
+
+  // add something from the far end, to test resizing
+  formula3 += "Rh";
+  CPPUNIT_ASSERT(formula!=formula3);
+  formula3 -= "Rh";
+  CPPUNIT_ASSERT(formula==formula3);
+
+  // removal of elements
+  formula -= "H";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)2);
+  CPPUNIT_ASSERT(formula.begin()!=formula.end());
+
+  formula -= "O";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)1);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)1);
+  CPPUNIT_ASSERT(formula.begin()!=formula.end());
+
+  formula -= "H";
+  CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  CPPUNIT_ASSERT_EQUAL(formula.getElementCount(),(unsigned int)0);
+  CPPUNIT_ASSERT(formula.begin()==formula.end());
+}
+
+void FormulaUnittest::parseTest(){
+  {
+    Formula formula("");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("H");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("H2");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("H2O");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("CH3COOH");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)4);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("CH3COONa");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("NaCH3COO");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("Na2CO3");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("CH2(COOH)2");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)4);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)4);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+  }
+  {
+    Formula formula("K4[Fe(CN)6]");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)6);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["K"],(unsigned int)4);
+    CPPUNIT_ASSERT_EQUAL(formula["Fe"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["N"],(unsigned int)6);
+  }
+  {
+    Formula formula("[CrCl3(H2O)3]");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)6);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["Cr"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["Cl"],(unsigned int)3);
+  }
+  {
+    Formula formula("Mg3[Fe(CN)6]2");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)12);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["Mg"],(unsigned int)3);
+    CPPUNIT_ASSERT_EQUAL(formula["Fe"],(unsigned int)2);
+    CPPUNIT_ASSERT_EQUAL(formula["N"],(unsigned int)12);
+  }
+  {
+    Formula formula("Na[Fe((HO2CCH2)2NCH2CH2N(CH2CO2H)2)]");
+    CPPUNIT_ASSERT_EQUAL(formula["H"],(unsigned int)16);
+    CPPUNIT_ASSERT_EQUAL(formula["O"],(unsigned int)8);
+    CPPUNIT_ASSERT_EQUAL(formula["C"],(unsigned int)10);
+    CPPUNIT_ASSERT_EQUAL(formula["Na"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["He"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["Mg"],(unsigned int)0);
+    CPPUNIT_ASSERT_EQUAL(formula["Fe"],(unsigned int)1);
+    CPPUNIT_ASSERT_EQUAL(formula["N"],(unsigned int)2);
+  }
+  {
+    CPPUNIT_ASSERT_THROW(Formula formula("74107"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("  "),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("nAcL"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("NAcL"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("Na Cl"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("1NaCl"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("Mag"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("AgCl)"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("(Na"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("(Mag)"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("MgCl2)"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("((MgCl2)"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("(MgCl2))"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("(MgCl2]"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("[MgCl2)"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("N(aCl"),ParseError);
+    CPPUNIT_ASSERT_THROW(Formula formula("Na()Cl"),ParseError);
+  }
+
+
+}
Index: src/unittests/FormulaUnittest.hpp
===================================================================
--- src/unittests/FormulaUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/FormulaUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,28 @@
+/*
+ * FormulaUnittest.hpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+#ifndef FORMULAUNITTEST_HPP_
+#define FORMULAUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class FormulaUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( FormulaUnittest );
+  CPPUNIT_TEST ( baseTest );
+  CPPUNIT_TEST ( parseTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void baseTest();
+  void parseTest();
+};
+
+#endif /* FORMULAUNITTEST_HPP_ */
Index: src/unittests/LineUnittest.cpp
===================================================================
--- src/unittests/LineUnittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/LineUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "LineUnittest.hpp"
 
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "Exceptions/LinearDependenceException.hpp"
 #include "Exceptions/SkewException.hpp"
@@ -17,4 +22,5 @@
 
 #include <iostream>
+#include <cmath>
 
 using namespace std;
@@ -352,2 +358,52 @@
   CPPUNIT_ASSERT_EQUAL(fixture,zeroVec);
 }
+
+void LineUnittest::sphereIntersectionTest(){
+  {
+    std::vector<Vector> res = la1->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT(testDirection(res[0],e1));
+    CPPUNIT_ASSERT(testDirection(res[1],e1));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+
+  {
+    std::vector<Vector> res = la2->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT(testDirection(res[0],e2));
+    CPPUNIT_ASSERT(testDirection(res[1],e2));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+
+  {
+    std::vector<Vector> res = la3->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT(testDirection(res[0],e3));
+    CPPUNIT_ASSERT(testDirection(res[1],e3));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+
+  {
+    std::vector<Vector> res = lp1->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT((res[0]==e1) || (res[0]==e2));
+    CPPUNIT_ASSERT((res[1]==e1) || (res[1]==e2));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+
+  {
+    std::vector<Vector> res = lp2->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT((res[0]==e2) || (res[0]==e3));
+    CPPUNIT_ASSERT((res[1]==e2) || (res[1]==e3));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+
+  {
+    std::vector<Vector> res = lp3->getSphereIntersections();
+    CPPUNIT_ASSERT_EQUAL(res.size(),(size_t)2);
+    CPPUNIT_ASSERT((res[0]==e3) || (res[0]==e1));
+    CPPUNIT_ASSERT((res[1]==e3) || (res[1]==e1));
+    CPPUNIT_ASSERT(res[0]!=res[1]);
+  }
+}
Index: src/unittests/LineUnittest.hpp
===================================================================
--- src/unittests/LineUnittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/LineUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "Line.hpp"
+#include "LinearAlgebra/Line.hpp"
 
 class LineUnittest : public CppUnit::TestFixture
@@ -22,4 +22,5 @@
   CPPUNIT_TEST ( intersectionTest );
   CPPUNIT_TEST ( rotationTest );
+  CPPUNIT_TEST ( sphereIntersectionTest );
   CPPUNIT_TEST_SUITE_END();
 
@@ -33,4 +34,5 @@
   void intersectionTest();
   void rotationTest();
+  void sphereIntersectionTest();
 
 private:
Index: src/unittests/LinkedCellUnitTest.cpp
===================================================================
--- src/unittests/LinkedCellUnitTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/LinkedCellUnitTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
@@ -50,6 +55,6 @@
         Walker = World::getInstance().createAtom();
         CPPUNIT_ASSERT(Walker != NULL && "could not create atom");
-        Walker->type = hydrogen;
-        *Walker->node = Vector(x, y, z );
+        Walker->setType(hydrogen);
+        Walker->setPosition(Vector(x, y, z ));
         TestMolecule->AddAtom(Walker);
       }
@@ -192,5 +197,5 @@
   atom *newAtom = World::getInstance().createAtom();
   newAtom->setName("test");
-  newAtom->x= Vector(1,1,1);
+  newAtom->setPosition(Vector(1,1,1));
   CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToNode(newAtom) );
   World::getInstance().destroyAtom(newAtom);
@@ -199,5 +204,5 @@
   newAtom = World::getInstance().createAtom();
   newAtom->setName("test");
-  newAtom->x = Vector(0,-1,0);
+  newAtom->setPosition(Vector(0,-1,0));
   CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToNode(newAtom) );
   World::getInstance().destroyAtom(newAtom);
@@ -216,5 +221,5 @@
       for (double z=0.5;z<3;z+=1.) {
         tester = Vector(x,y,z);
-        CPPUNIT_ASSERT_EQUAL( true, LC->SetIndexToVector(&tester) );
+        CPPUNIT_ASSERT_EQUAL( true, LC->SetIndexToVector(tester) );
       }
   // check corners of each cell
@@ -224,5 +229,5 @@
         tester= Vector(x,y,z);
         cout << "Tester is at " << tester << "." << endl;
-        CPPUNIT_ASSERT_EQUAL( true, LC->SetIndexToVector(&tester) );
+        CPPUNIT_ASSERT_EQUAL( true, LC->SetIndexToVector(tester) );
       }
   // check out of bounds
@@ -232,10 +237,10 @@
         tester = Vector(x,y,z);
         cout << "The following test is supposed to fail and produce an ERROR." << endl;
-        CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToVector(&tester) );
+        CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToVector(tester) );
       }
   // check nonsense vectors
   tester= Vector(-423598,3245978,29349);
   cout << "The following test is supposed to fail and produce an ERROR." << endl;
-  CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToVector(&tester) );
+  CPPUNIT_ASSERT_EQUAL( false, LC->SetIndexToVector(tester) );
 };
 
@@ -249,5 +254,5 @@
 
   tester= Vector(0.5,0.5,0.5);
-  LC->SetIndexToVector(&tester);
+  LC->SetIndexToVector(tester);
   LC->GetNeighbourBounds(lower, upper);
   for (int i=0;i<NDIM;i++)
@@ -268,5 +273,5 @@
   // get all atoms
   tester= Vector(1.5,1.5,1.5);
-  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(&tester) );
+  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(tester) );
   ListOfPoints = LC->GetallNeighbours();
   size = ListOfPoints->size();
@@ -285,10 +290,10 @@
   // get all atoms in one corner
   tester= Vector(0.5, 0.5, 0.5);
-  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(&tester) );
+  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(tester) );
   ListOfPoints = LC->GetallNeighbours();
   size=ListOfPoints->size();
   CPPUNIT_ASSERT_EQUAL( (size_t)8, size );
   for(molecule::iterator iter = TestMolecule->begin(); iter != TestMolecule->end(); ++iter){
-    if (((*iter)->x[0] <2) && ((*iter)->x[1] <2) && ((*iter)->x[2] <2)) {
+    if (((*iter)->at(0) <2) && ((*iter)->at(1) <2) && ((*iter)->at(2) <2)) {
       ListOfPoints->remove(*iter);
       size--;
@@ -303,5 +308,5 @@
   // get all atoms from one corner
   tester = Vector(0.5, 0.5, 0.5);
-  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(&tester) );
+  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(tester) );
   ListOfPoints = LC->GetallNeighbours(3);
   size=ListOfPoints->size();
@@ -329,10 +334,10 @@
   // get all points around central arom with radius 1.
   tester= Vector(1.5,1.5,1.5);
-  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(&tester) );
+  CPPUNIT_ASSERT_EQUAL ( true, LC->SetIndexToVector(tester) );
   ListOfPoints = LC->GetPointsInsideSphere(1., &tester);
   size = ListOfPoints->size();
   CPPUNIT_ASSERT_EQUAL( (size_t)7, size );
   for(molecule::iterator iter = TestMolecule->begin(); iter!=TestMolecule->end();++iter){
-    if (((*iter)->x.DistanceSquared(tester) - 1.) < MYEPSILON ) {
+    if (((*iter)->DistanceSquared(tester) - 1.) < MYEPSILON ) {
       ListOfPoints->remove(*iter);
       size--;
